<?php

namespace Treewec;

/**
 * Test class for AdminURLInspector.
 * Generated by PHPUnit on 2012-07-03 at 14:44:02.
 * @group url
 */
class AdminURLInspectorTest extends \PHPUnit_Framework_TestCase {

    /** @var ExceptionHelper */
    private $exceptionHelper;
    /** @var PublicURLInspector */
    private $inspector;

    protected function setUp() {        
        $this->exceptionHelper = new ExceptionHelper();
        $_SERVER['REQUEST_URI'] = '';
    }

    public function testCheck() {
        $this->assertAdmin();
        $this->assertAction();
        $this->assertEditor();
    }
    
    private function assertAdmin() {                
        $this->setInspector(array('admin' => 'home'));
        $this->setInspector(array('admin' => '', 'path' => 'teams/'));
        $this->setInspector(array('admin' => 'themes', 'path' => 'teams/'));
        $this->setInspector(array('admin' => 'plugins', 'path' => 'teams/'));
        // admin must be valid value 
        $this->setInspectorAndAssertException(array('path' => '', 'admin' => 'hello'));
        // path must be empty (not for file, themes, plugin)
        $this->setInspectorAndAssertException(array('path' => 'test', 'admin' => 'settings'));
    }
    
    private function assertAction() {
        $this->setInspector(array('action' => 'rename'));// valid: file (not set ADMIN)
        $this->setInspectorAndAssertException(array('action' => 'helloWorld'));// invalid value
        $this->setInspectorAndAssertException(array('action' => 'rename', 'admin' => 'settings'));// only in file         
        $this->setInspectorAndAssertException(array('action' => 'rename', 'editor' => 'plain'));// editor cannot be set
    }
    
    private function assertEditor() {
        $this->setInspector(array('editor' => 'plain'));// valid: file (ADMIN is not set)
        $this->setInspectorAndAssertException(array('action' => 'helloWorld'));// invalid value
        $this->setInspectorAndAssertException(array('admin' => 'settings', 'editor' => 'plain'));// only in file         
        $this->setInspectorAndAssertException(array('action' => 'rename', 'editor' => 'plain'));// action cannot be set
    }
    
    private function assertExtraArguments() {  
        // only admin, path, editor, action can be set
        $_GET['new'] = 'file';
        $this->setInspectorAndAssertException(array('admin' => 'home'));
    }

    private function setInspectorAndAssertException($array) {
        $this->setInspector($array);
        $this->assertException();
    }
    
    private function setInspector($array) {
        if (!array_key_exists('path', $array)) {
            $array = array_merge($array, array('path' => ''));// add valid path
        }
        $this->inspector = new AdminURLInspector();
        $arrayHolder = new Holders\ArrayHolder($array);
        $this->inspector->addInspectedObject(URLArgs::createFromArrayHolder($arrayHolder));
    }
    
    private function assertException() {
        $this->exceptionHelper->catchExceptionInCallback(
                '\Treewec\Exceptions\ClientRequestException', 
                array($this->inspector, 'check'), 
                false
        );
    }
}

?>
